
/*
 * Copyright (C) 2024 Web Server LLC
 */


#ifndef _NGX_HTTP_WASM_HOST_H_INCLUDED_
#define _NGX_HTTP_WASM_HOST_H_INCLUDED_


#include <ngx_config.h>
#include <ngx_core.h>
#include <ngx_http.h>
#include <ngx_wasm.h>


typedef struct {
    ngx_wasm_host_t                   wh; /* must be first */

    ngx_http_request_t               *request;

    int32_t                           lfd;    /* preopen log fd */

    ngx_array_t                      *ce_argv;
    ngx_array_t                      *ce_kvs;
} ngx_http_wasm_host_t;


/* http request handler state */
typedef struct {
    ngx_http_request_t               *request;
    ngx_http_client_body_handler_pt   body_handler;
    void                             *body_handler_params;
    ngx_str_t                         reject_msg;
    unsigned                          in_syscall:1;
    unsigned                          post_body_called:1;
} ngx_wasm_http_ctx_t;


ngx_int_t ngx_http_wasm_host_register_api(ngx_conf_t *cf,
    ngx_wasm_handle_ops_t *ops);

#endif /* _NGX_HTTP_WASM_HOST_H_INCLUDED_ */
